Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.scheduling.quartz
Class MethodInvokingJobDetailFactoryBean

    java.lang.Object
      org.springframework.util.MethodInvoker
          org.springframework.beans.support.ArgumentConvertingMethodInvoker
              org.springframework.scheduling.quartz.MethodInvokingJobDetailFactoryBean

All Implemented Interfaces:
  BeanClassLoaderAware, BeanFactoryAware, BeanNameAware, FactoryBean, InitializingBean

    public class MethodInvokingJobDetailFactoryBean

extends ArgumentConvertingMethodInvoker
implements FactoryBean, BeanNameAware, BeanClassLoaderAware, BeanFactoryAware, InitializingBean

`FactoryBean` that exposes a `JobDetail` object which delegates job execution to a specified (static or non-static) method. Avoids the need for implementing a one-line Quartz Job that just invokes an existing service method on a Spring-managed target bean.

Inherits common configuration properties from the `MethodInvoker` base class, such as `"targetObject"` and `"targetMethod"`, adding support for lookup of the target bean by name through the `"targetBeanName"` property (as alternative to specifying a "targetObject" directly, allowing for non-singleton target objects).

Supports both concurrently running jobs and non-currently running jobs through the "concurrent" property. Jobs created by this MethodInvokingJobDetailFactoryBean are by default volatile and durable (according to Quartz terminology).

NOTE: JobDetails created via this FactoryBean are not serializable and thus not suitable for persistent job stores. You need to implement your own Quartz Job as a thin wrapper for each case where you want a persistent job to delegate to a specific service method.

Since:
  18.02.2004
Author:
  Juergen Hoeller, Alef Arendsen
See Also:
  `setTargetBeanName(java.lang.String)`, `MethodInvoker.setTargetObject(java.lang.Object)`, `MethodInvoker.setTargetMethod(java.lang.String)`, `setConcurrent(boolean)`

Nested Class Summary
`static class` | `MethodInvokingJobDetailFactoryBean.MethodInvokingJob` Quartz Job implementation that invokes a specified method.
`static class` | `MethodInvokingJobDetailFactoryBean.StatefulMethodInvokingJob` Extension of the MethodInvokingJob, implementing the StatefulJob interface.

Constructor Summary
`MethodInvokingJobDetailFactoryBean()`

Method Summary
`void` | `afterPropertiesSet()` Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).
`Object` | `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
`Class` | `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`Class` | `getTargetClass()` Overridden to support the `"targetBeanName"` feature.
`Object` | `getTargetObject()` Overridden to support the `"targetBeanName"` feature.
`boolean` | `isSingleton()` Is the object managed by this factory a singleton?
`protected void` | `postProcessJobDetail(JobDetail jobDetail)` Callback for post-processing the JobDetail to be exposed by this FactoryBean.
`protected Class` | `resolveClassName(String className)` Resolve the given class name into a Class.
`void` | `setBeanClassLoader(ClassLoader classLoader)` Callback that supplies the bean `class loader` to a bean instance.
`void` | `setBeanFactory(BeanFactory beanFactory)` Callback that supplies the owning factory to a bean instance.
`void` | `setBeanName(String beanName)` Set the name of the bean in the bean factory that created this bean.
`void` | `setConcurrent(boolean concurrent)` Specify whether or not multiple jobs should be run in a concurrent fashion.
`void` | `setGroup(String group)` Set the group of the job.
`void` | `setJobListenerNames(String[] names)` Set a list of JobListener names for this job, referring to non-global JobListeners registered with the Scheduler.
`void` | `setName(String name)` Set the name of the job.
`void` | `setTargetBeanName(String targetBeanName)` Set the name of the target bean in the Spring BeanFactory.

Methods inherited from class org.springframework.beans.support.ArgumentConvertingMethodInvoker
`doFindMatchingMethod, findMatchingMethod, getDefaultTypeConverter, getTypeConverter, registerCustomEditor, setTypeConverter`

Methods inherited from class org.springframework.util.MethodInvoker
`getArguments, getPreparedMethod, getTargetMethod, getTypeDifferenceWeight, invoke, isPrepared, prepare, setArguments, setStaticMethod, setTargetClass, setTargetMethod, setTargetObject`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### MethodInvokingJobDetailFactoryBean

    public MethodInvokingJobDetailFactoryBean()

Method Detail

### setName

    public void setName(String name)

  Set the name of the job.

  Default is the bean name of this FactoryBean.

  See Also:
    `JobDetail.setName(java.lang.String)`

### setGroup

    public void setGroup(String group)

  Set the group of the job.

  Default is the default group of the Scheduler.

  See Also:
    `JobDetail.setGroup(java.lang.String)`, `Scheduler.DEFAULT_GROUP`

### setConcurrent

    public void setConcurrent(boolean concurrent)

  Specify whether or not multiple jobs should be run in a concurrent fashion. The behavior when one does not want concurrent jobs to be executed is realized through adding the `StatefulJob` interface. More information on stateful versus stateless jobs can be found here.

  The default setting is to run jobs concurrently.

### setTargetBeanName

    public void setTargetBeanName(String targetBeanName)

  Set the name of the target bean in the Spring BeanFactory.

  This is an alternative to specifying `"targetObject"`, allowing for non-singleton beans to be invoked. Note that specified "targetObject" and `"targetClass"` values will override the corresponding effect of this "targetBeanName" setting (i.e. statically pre-define the bean type or even the bean object).

### setJobListenerNames

    public void setJobListenerNames(String[] names)

  Set a list of JobListener names for this job, referring to non-global JobListeners registered with the Scheduler.

  A JobListener name always refers to the name returned by the JobListener implementation.

  See Also:
    `SchedulerFactoryBean.setJobListeners(org.quartz.JobListener[])`, `JobListener.getName()`

### setBeanName

    public void setBeanName(String beanName)

  Description copied from interface: `BeanNameAware`
  Set the name of the bean in the bean factory that created this bean.

  Invoked after population of normal bean properties but before an init callback such as `InitializingBean.afterPropertiesSet()` or a custom init-method.

  Specified by:
    `setBeanName` in interface `BeanNameAware`
  Parameters:
    `beanName` - the name of the bean in the factory. Note that this name is the actual bean name used in the factory, which may differ from the originally specified name: in particular for inner bean names, the actual bean name might have been made unique through appending "#..." suffixes. Use the `BeanFactoryUtils.originalBeanName(String)` method to extract the original bean name (without suffix), if desired.

### setBeanClassLoader

    public void setBeanClassLoader(ClassLoader classLoader)

  Description copied from interface: `BeanClassLoaderAware`
  Callback that supplies the bean `class loader` to a bean instance.

  Invoked after the population of normal bean properties but before an initialization callback such as `InitializingBean's` `InitializingBean.afterPropertiesSet()` method or a custom init-method.

  Specified by:
    `setBeanClassLoader` in interface `BeanClassLoaderAware`
  Parameters:
    `classLoader` - the owning class loader; may be `null` in which case a default `ClassLoader` must be used, for example the `ClassLoader` obtained via `ClassUtils.getDefaultClassLoader()`

### setBeanFactory

    public void setBeanFactory(BeanFactory beanFactory)

  Description copied from interface: `BeanFactoryAware`
  Callback that supplies the owning factory to a bean instance.

  Invoked after the population of normal bean properties but before an initialization callback such as `InitializingBean.afterPropertiesSet()` or a custom init-method.

  Specified by:
    `setBeanFactory` in interface `BeanFactoryAware`
  Parameters:
    `beanFactory` - owning BeanFactory (never `null`). The bean can immediately call methods on the factory.
  See Also:
    `BeanInitializationException`

### resolveClassName

    protected Class resolveClassName(String className)
                              throws ClassNotFoundException

  Description copied from class: `MethodInvoker`
  Resolve the given class name into a Class.

  The default implementations uses `ClassUtils.forName`, using the thread context class loader.

  Overrides:
    `resolveClassName` in class `MethodInvoker`
  Parameters:
    `className` - the class name to resolve
  Returns:
    the resolved Class
  Throws:
    `ClassNotFoundException` - if the class name was invalid

### afterPropertiesSet

    public void afterPropertiesSet()
                            throws ClassNotFoundException,
                                   NoSuchMethodException

  Description copied from interface: `InitializingBean`
  Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).

  This method allows the bean instance to perform initialization only possible when all bean properties have been set and to throw an exception in the event of misconfiguration.

  Specified by:
    `afterPropertiesSet` in interface `InitializingBean`
  Throws:
    `ClassNotFoundException`
    `NoSuchMethodException`

### postProcessJobDetail

    protected void postProcessJobDetail(JobDetail jobDetail)

  Callback for post-processing the JobDetail to be exposed by this FactoryBean.

  The default implementation is empty. Can be overridden in subclasses.

  Parameters:
    `jobDetail` - the JobDetail prepared by this FactoryBean

### getTargetClass

    public Class getTargetClass()

  Overridden to support the `"targetBeanName"` feature.

  Overrides:
    `getTargetClass` in class `MethodInvoker`

### getTargetObject

    public Object getTargetObject()

  Overridden to support the `"targetBeanName"` feature.

  Overrides:
    `getTargetObject` in class `MethodInvoker`

### getObject

    public Object getObject()

  Description copied from interface: `FactoryBean`
  Return an instance (possibly shared or independent) of the object managed by this factory.

  As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

  If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

  As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

  Specified by:
    `getObject` in interface `FactoryBean`
  Returns:
    an instance of the bean (can be `null`)
  See Also:
    `FactoryBeanNotInitializedException`

### getObjectType

    public Class getObjectType()

  Description copied from interface: `FactoryBean`
  Return the type of object that this FactoryBean creates, or `null` if not known in advance.

  This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

  In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

  This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

  NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

  Specified by:
    `getObjectType` in interface `FactoryBean`
  Returns:
    the type of object that this FactoryBean creates, or `null` if not known at the time of the call
  See Also:
    `ListableBeanFactory.getBeansOfType(java.lang.Class)`

### isSingleton

    public boolean isSingleton()

  Description copied from interface: `FactoryBean`
  Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

  NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

  The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

  NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

  Specified by:
    `isSingleton` in interface `FactoryBean`
  Returns:
    whether the exposed object is a singleton
  See Also:
    `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2008 The Spring Framework.